package com.example.nfcread;

import android.nfc.NfcAdapter;
import android.os.Build;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.nio.ByteBuffer;
import android.nfc.Tag;
import android.util.Log;
import android.widget.Toast;


public class MainActivity extends AppCompatActivity {
    private TextView mTextView;
    private NfcAdapter mNfcAdapter;
    private NamedLightsManager mNamedLightsManagerCompat;
    private Handler flash =  new Handler();
    private String record;
    private Button save,reset;
    private String CardId="";
    private static final int READER_FLAGS = NfcAdapter.FLAG_READER_NFC_A;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mNamedLightsManagerCompat = NamedLightsManager.getInstance(this);
        mTextView = (TextView)findViewById(R.id.textView);
        save = findViewById(R.id.save);
        reset = findViewById(R.id.reset);
        save.setOnClickListener(new Button.OnClickListener(){
            @Override public void onClick(View v) {
                record=String.valueOf(CardId);
                Flash("blue");
                Toast toast = Toast.makeText(MainActivity.this,
                        "Save : "+record, Toast.LENGTH_LONG);
                toast.show();
            }
        });
        Log.d("","");
        reset.setOnClickListener(new Button.OnClickListener(){
            @Override public void onClick(View v) {
                record="";
                CardId="";
                mTextView.setText("");
                Toast toast = Toast.makeText(MainActivity.this,
                        "  Reset  ", Toast.LENGTH_LONG);
                toast.show();
            }
        });


        mNfcAdapter = NfcAdapter.getDefaultAdapter(this);
        if (mNfcAdapter != null)
            mTextView.setText(" support NFC");
         else
            mTextView.setText(" not support NFC");

    }


    private Handler handler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 1:
                    mTextView.setText(CardId);
                    break;
            }
        }
    };

    private NfcAdapter.ReaderCallback mReaderCallback = new NfcAdapter.ReaderCallback() {
        @Override
        public void onTagDiscovered(Tag tag) {
            Log.d("", "onTagDiscovered: " + tag.describeContents()+"    v:"+tag.toString());
            CardId=ByteArrayToHexString(tag.getId());

            if (CardId.equals(record))
                Flash( "green");
            else
                Flash( "red");

            new Thread() {
                @Override
                public void run() {
                    Message message = new Message();
                    message.what = 1;
                    handler.sendMessage(message);
                }
            }.start();


        }
    };

    @Override
    protected void onResume() {
        super.onResume();
        enableReaderMode();
    }

    @Override
    protected void onPause(){
        super.onPause();
        disableReaderMode();
    }

    private void enableReaderMode() {
        Log.i("", "Enabling reader mode");
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            mNfcAdapter.enableReaderMode(this, mReaderCallback, READER_FLAGS, null);
        }

    }

    private void disableReaderMode() {
        Log.i("", "Disabling reader mode");
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            mNfcAdapter.disableReaderMode(this);
        }
    }




    private String ByteArrayToHexString(byte[] bytearray) {
        int hex, input;
        String[] hex_table = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a",
                "b", "c", "d", "e", "f" };
        String out = "";
        for(byte data:bytearray){
            input = (int) data & 0xff;
            hex = (input >> 4) & 0x0f;
            out += hex_table[hex];
            hex = input & 0x0f;
            out += hex_table[hex];
        }

        return out;
    }

    void doPost(String name, float brightness, int color) {
        NamedLight[] lights;
        lights = mNamedLightsManagerCompat.getLightsByNameEx(name);
        if ((color & 0xffffff) == 0) color = 0;
        int effectiveIntColor = ((((int) (Math.min(brightness, 1.0) * 255.0)) << 24) | (color & 0xffffff));
        for (NamedLight light : lights)
            light.setColor(effectiveIntColor);
    }

    void Flash( String light) {
        switch(light){
            case "red":
                doPost("frame", 1, 0xff0000);break;
            case "blue":
                doPost("frame", 1, 0x0000ff);break;
            case "green":
                doPost("frame", 1, 0x00ff00);break;
        }
        flash.postDelayed(new Runnable() {
            @Override
            public void run() {
                doPost("frame", 0, 0);
            }
        },  500);
    }

}

